-- updates for 6.3


CREATE TABLE TEMPLATE_MAPPING(
TEMPLATE_ID bigint NOT NULL ,
COLUMN_NAME varchar(50) NOT NULL ,
COL_DESC nvarchar(255) NOT NULL ,
COMPONENT_ID varchar(50) NOT NULL ,
COMPONENT_TYPE varchar(50) NOT NULL ,
CON_ID bigint NOT NULL ,
ITEM_SCHEME_ID bigint NOT NULL ,
PRIMARY KEY (TEMPLATE_ID))
;

ALTER TABLE TEMPLATE_MAPPING ADD CONSTRAINT FK_ITEM_SCHEME_TEMPLATE FOREIGN KEY (ITEM_SCHEME_ID) REFERENCES ITEM_SCHEME (ITEM_SCHEME_ID)
;

ALTER TABLE TEMPLATE_MAPPING ADD CONSTRAINT FK_CON_ID_TEMPLATE FOREIGN KEY (CON_ID) REFERENCES CONCEPT (CON_ID)
;

ALTER TABLE TEMPLATE_MAPPING ADD CONSTRAINT FK_COMPONENT_COMMON_TEMPLATE FOREIGN KEY (TEMPLATE_ID) REFERENCES COMPONENT_COMMON (COMP_ID)
ON DELETE CASCADE
;

CREATE TABLE TM_TRANSCODING(
TEMPLATE_ID bigint NOT NULL ,
LOCAL_CODE nvarchar(150) NOT NULL ,
DSD_CODE varchar(150) NOT NULL ,
PRIMARY KEY (TEMPLATE_ID,LOCAL_CODE))
;

ALTER TABLE TM_TRANSCODING ADD CONSTRAINT FK_TEMPLATE_TRANSCODING FOREIGN KEY (TEMPLATE_ID) REFERENCES TEMPLATE_MAPPING (TEMPLATE_ID)
ON DELETE CASCADE
;


CREATE TABLE TM_TIME_TRANSCODING(
TEMPLATE_ID bigint NOT NULL ,
FREQ varchar(5) NOT NULL ,
IS_DATE int NOT NULL ,
Y_START bigint NULL ,
Y_LENGTH bigint NULL ,
P_START bigint NULL ,
P_LENGTH bigint NULL ,
PRIMARY KEY (TEMPLATE_ID,FREQ))
;

ALTER TABLE TM_TIME_TRANSCODING ADD CONSTRAINT FK_TEMPLATE_TIME FOREIGN KEY (TEMPLATE_ID) REFERENCES TEMPLATE_MAPPING (TEMPLATE_ID)
ON DELETE CASCADE
;
IF EXISTS (SELECT * FROM dbo.SYSOBJECTS WHERE id = object_id('INSERT_TEMPLATE_MAPPING') AND  OBJECTPROPERTY(id, 'IsProcedure') = 1)
DROP PROC INSERT_TEMPLATE_MAPPING
;

CREATE PROCEDURE INSERT_TEMPLATE_MAPPING
@p_column_name varchar(50) ,
@p_col_desc nvarchar(255) ,
@p_component_id varchar(50) ,
@p_component_type varchar(50) ,
@p_con_id bigint ,
@p_item_scheme_id bigint ,
@p_pk bigint OUT
AS
BEGIN
	SET NOCOUNT ON;
	SET XACT_ABORT ON;
	DECLARE @starttrancount int;
	SET @starttrancount = @@TRANCOUNT;
	BEGIN TRY
		IF @starttrancount = 0 
			BEGIN TRANSACTION

		EXEC INSERT_COMPONENT_COMMON @p_pk = @p_pk OUTPUT;
		INSERT INTO TEMPLATE_MAPPING (TEMPLATE_ID,COLUMN_NAME,COL_DESC,COMPONENT_ID,COMPONENT_TYPE,CON_ID,ITEM_SCHEME_ID) VALUES (@p_pk, @p_column_name, @p_col_desc, @p_component_id, @p_component_type, @p_con_id, @p_item_scheme_id);
	IF @starttrancount = 0
	COMMIT TRANSACTION

	END TRY
	BEGIN CATCH
		DECLARE @ErrorMessage NVARCHAR(4000);
		DECLARE @ErrorSeverity INT;
		DECLARE @ErrorState INT;

		SELECT 
			@ErrorMessage = ERROR_MESSAGE(),
			@ErrorSeverity = ERROR_SEVERITY(),
			@ErrorState = ERROR_STATE();
		IF XACT_STATE() <> 0 AND @starttrancount = 0 
			ROLLBACK TRANSACTION
	RAISERROR (@ErrorMessage, -- Message text.
				@ErrorSeverity, -- Severity.
				@ErrorState -- State.
				);
	END CATCH
END

;


-- always last
update DB_VERSION SET VERSION = '6.3'
;

